# coding: utf-8

"""
    Wandelbots NOVA API

    Interact with robots in an easy and intuitive way.  > **Note:** API version 2 is experimental and will experience functional changes. 

    The version of the OpenAPI document: 2.0.0 beta
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from wandelbots_api_client.v2.models.jogging_details import JoggingDetails
from wandelbots_api_client.v2.models.trajectory_details import TrajectoryDetails
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

EXECUTEDETAILS_ONE_OF_SCHEMAS = ["JoggingDetails", "TrajectoryDetails"]

class ExecuteDetails(BaseModel):
    """
    ExecuteDetails
    """
    # data type: JoggingDetails
    oneof_schema_1_validator: Optional[JoggingDetails] = None
    # data type: TrajectoryDetails
    oneof_schema_2_validator: Optional[TrajectoryDetails] = None
    actual_instance: Optional[Union[JoggingDetails, TrajectoryDetails]] = None
    one_of_schemas: Set[str] = { "JoggingDetails", "TrajectoryDetails" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = ExecuteDetails.model_construct()
        error_messages = []
        match = 0
        # validate data type: JoggingDetails
        if not isinstance(v, JoggingDetails):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoggingDetails`")
        else:
            match += 1
        # validate data type: TrajectoryDetails
        if not isinstance(v, TrajectoryDetails):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TrajectoryDetails`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in ExecuteDetails with oneOf schemas: JoggingDetails, TrajectoryDetails. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in ExecuteDetails with oneOf schemas: JoggingDetails, TrajectoryDetails. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # use oneOf discriminator to lookup the data type
        _data_type = json.loads(json_str).get("kind")
        if not _data_type:
            raise ValueError("Failed to lookup data type from the field `kind` in the input.")

        # check if data type is `JoggingDetails`
        if _data_type == "JOGGING":
            instance.actual_instance = JoggingDetails.from_json(json_str)
            return instance

        # check if data type is `TrajectoryDetails`
        if _data_type == "TRAJECTORY":
            instance.actual_instance = TrajectoryDetails.from_json(json_str)
            return instance

        # check if data type is `JoggingDetails`
        if _data_type == "JoggingDetails":
            instance.actual_instance = JoggingDetails.from_json(json_str)
            return instance

        # check if data type is `TrajectoryDetails`
        if _data_type == "TrajectoryDetails":
            instance.actual_instance = TrajectoryDetails.from_json(json_str)
            return instance

        # deserialize data into JoggingDetails
        try:
            instance.actual_instance = JoggingDetails.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TrajectoryDetails
        try:
            instance.actual_instance = TrajectoryDetails.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into ExecuteDetails with oneOf schemas: JoggingDetails, TrajectoryDetails. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into ExecuteDetails with oneOf schemas: JoggingDetails, TrajectoryDetails. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], JoggingDetails, TrajectoryDetails]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


